#include <stdlib.h>
#include <string.h>
#include "gui/support.h"
#include "applicationGUI.h"
#include "main.h"
#include "test.h"
#include "user.h"
#include "widgetOperations.h"
#include "generateParameter.h"
//#include "commandUtils.h"
char *replace(char *st, char *orig, char *repl) 
{
  
  int n=strlen(st)-strlen(orig)+strlen(repl)+1;
  
  char * buffer= malloc(n);
  char *ch;
  if (!(ch = strstr(st, orig)))
  {
    free(buffer);
    return st;
  }
  strncpy(buffer, st, ch-st);  
  buffer[ch-st] = 0;
  sprintf(buffer+(ch-st), "%s%s", repl, ch+strlen(orig));
  buffer[strlen(st)-strlen(orig)+strlen(repl)]=0;
  return buffer;
}
gchar* expireDate(gchar* c)
{
  char* ret=calloc(1,60);
  char* temp=calloc(1,5);
  if (strcmp(getTextFromGtkEntry("txtExpireDay"),"")!=0)
  {
    sprintf(temp,"%02d", atoi(getTextFromGtkEntry("txtExpireDay")));
    strcat(ret,temp);
    if (strcmp(getTextFromGtkEntry("txtExpireMonth"),"")!=0)
    {
      strcat(ret,"-");
      sprintf(temp,"%02d", atoi(getTextFromGtkEntry("txtExpireMonth")));
      strcat(ret,temp);
      if (strcmp(getTextFromGtkEntry("txtExpireYear"),""))
      {
	strcat(ret,"-");
	sprintf(temp,"%04d", atoi(getTextFromGtkEntry("txtExpireYear")));
	strcat(ret,temp);
        free(temp);
	return ret;
      }
    }
    free(temp);
    strcpy(ret,"");
    return ret;
    
  }
  free(temp);
  return ret;
}
gchar* userPassword(gchar * c)
{
  char comando[120];
  char *pass=malloc(80);
  sprintf(comando, "perl -e 'print crypt(%s, aa)'", c);  
  FILE *fp = popen(comando,"r");  
  fscanf(fp,"%s",pass);  
  pclose(fp); 
  return  pass;
}

gchar*  completeUserName(char* c)
{
  char* ret=calloc(1,150);
  if (strcmp(c, "")!=0)
  {    
    sprintf(ret, "\"%s\"", c);
  }
  else
  {
    strcpy(ret,"");
  }
  return ret;
}
gchar*  parseGroups(char* c)
{
  char* ret=calloc(1,150);
  strcat(ret,c);
  return ret;
}
gchar* completeDir(char *c)
{
  char* ret= malloc(150);
  gchar* base= (gchar *) gtk_entry_get_text((GtkEntry*) widgetFromWindow("txtBasedir"));
  strcpy(ret,base);
  strcat(ret,"/");
  strcat(ret,c);
  return ret;
}



GSList *  initialize_widgets_operations(int optionState)
{
  extern GtkWidget* window;
  GSList *opList=NULL;
  
  if (optionState!=MANY_USERS_CUSTOM_PASSWORD)
  {
    addNewOperation(&opList,window,lookup_widget(window,"txtPassword"),userPassword,GTKENTRY,PASSWORD);     
  }
    
 // if (strcmp(gtk_entry_get_text(GTK_ENTRY(widgetFromWindow("txtHomedir"))), gtk_entry_get_text(GTK_ENTRY(widgetFromWindow("txtName"))))!=0)
 // {
    addNewOperation(&opList,window,lookup_widget(window,"txtHomedir"),completeDir,GTKENTRY,FOLDER);
 // }
  //else
 // {
  //  addNewOperation(&opList,window,lookup_widget(window,"txtHomedir"),0,GTKENTRY,FOLDER);
 // }

  addNewOperation(&opList,window,lookup_widget(window,"tblGroupContainer"),parseGroups,GTKCONTAINER,GROUPS);
  
    addNewOperation(&opList,window,lookup_widget(window,"txtShell"),0,GTKENTRY,SHELL);
    
    addNewOperation(&opList,window,lookup_widget(window,"txtUID"),0,GTKENTRYINTEGER,UID);
  
    addNewOperation(&opList,window,lookup_widget(window,"txtComment"),completeUserName,GTKENTRY,FULLNAME);
    
    addNewOperation(&opList,window,lookup_widget(window,"chkCreateFolder"),0,GTKCHECKBUTTON,CREATEFOLDER);

    addNewOperation(&opList,window,lookup_widget(window,"chkUniqueUID"),0,GTKCHECKBUTTON,UNIQUEID);
    
    addNewOperation(&opList,window,lookup_widget(window,"chkCreateUserGroup"),0,GTKCHECKBUTTON,CREATEUSERGROUP);
  
    addNewOperation(&opList,window,lookup_widget(window,"txtExpireMonth"),expireDate,GTKENTRY,EXPIREDATE);
 
    addNewOperation(&opList,window,lookup_widget(window,"txtName"),0,GTKENTRY,USERNAME);

  return opList;
}

const char* getTextFromGtkEntry(char* GtkEntryName)
{
  return gtk_entry_get_text(GTK_ENTRY(widgetFromWindow(GtkEntryName)));
}
int usersToAdd()
{
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widgetFromWindow("toggleManyUsers"))))
  {
       return atoi(getTextFromGtkEntry("txtUserNumber"));
  }
  else
  {
        return -1;
  }
}
int  getStartNumber()
{
  extern GtkWidget* window;
  return atoi(gtk_entry_get_text(GTK_ENTRY(lookup_widget(window,"txtStartNumber"))));
}
GtkWidget * getWindowFromName(char* aName)
{
  extern GtkWidget* window;
  if (strcmp("dialogCustomPassword",aName)==0)
  {
   	return create_dialogCustomPassword();
  }
  if (strcmp("addUserWindow",aName)==0)
  {
 	return window;      
  }
  return 0;
}

char* append(char* a, char *b, int cr)
{
  char* temp;
  int size=strlen(a)+(strlen(b)+10);
  if (cr)
    size+=2;    
  temp=malloc(size);
  strcpy(temp,a);
  strcat(temp,b);

  if (cr)
  {
    temp[size-2]='\n';
    temp[size-1]=0;
  }
  return temp;
  
}
void informErrorList(GSList* errorList)
{
  int pos;     
  char * cadena= "Se han producido los siguientes errores al momento de agregar los usuarios: \n" ;  
  char*b;
  for (pos=0; pos<g_slist_length(errorList); pos++)
  {
    b=g_slist_nth_data(errorList,pos);       
    cadena=append(cadena,b,1);   
    
  }
    GtkMessageDialog * errorMessage=(GtkMessageDialog *) gtk_message_dialog_new(NULL, \
    GTK_DIALOG_MODAL , GTK_MESSAGE_ERROR,GTK_BUTTONS_CLOSE,cadena);
    
    gtk_dialog_run((GtkDialog*)errorMessage);
    gtk_widget_destroy ((GtkWidget*)errorMessage);
    free(cadena);
  
}
char* replaceMultipleCharacter(char* string, int number)
{
	char*totalString=string;
	char*ch=string;
	char* temp;
	char* temp1;
	temp=malloc(10);
	while ((ch=strchr(totalString,'%')))
	{
		ch++;
		
		switch (*ch)
		{
			case 'i':
				sprintf(temp,"%d",number);
				temp1=replace(totalString,"%i",temp);	
				if (totalString!=string)
				{					   	
					free(totalString);
				}
				totalString=temp1;
				break;
			default:
				return totalString;
				break;
		}		
	}
	free(temp);
	return totalString;
}
enum eError detectOperation()
{
   enum eError state1;
    if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widgetFromWindow("rbAutoPassword"))))
     {
       state1= MANY_USERS_NO_AUTO_PASSWORD_PROVIDED;
     }
     else
     {     
        state1= MANY_USERS_CUSTOM_PASSWORD;
     }
     return state1;
  
}
int appGUI_setPassword( sUser* user)
{ 
   int bcustomPassword=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widgetFromWindow("rbCustomPassword")));
   int bPasswordAsUsername=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widgetFromWindow("rbPasswordAsUsername")));      
    if (bcustomPassword)
	{
	    char* customPassword;
	   GtkWidget* dialog= create_dialogCustomPassword();
	   gtk_label_set_text(GTK_LABEL(lookup_widget(dialog,"lblUser")),getUserInfo(user,USERNAME));
	     
	   gint result = gtk_dialog_run (GTK_DIALOG (dialog));
	  switch (result)
	    {
	    case GTK_RESPONSE_ACCEPT:		
	      	customPassword = (char*)gtk_entry_get_text(GTK_ENTRY(lookup_widget(dialog,"txtPassword")));	      
	      	break;
	    default:
	      	gtk_widget_destroy (dialog); 
	      	return CANCEL_OPERATION;
	      	break;
	      
	    }
	    char* passwordTemp=userPassword(customPassword);
	    setField(user,passwordTemp,PASSWORD);
	    free(passwordTemp);
	    gtk_widget_destroy (dialog); 	   
	}
	else if (bPasswordAsUsername)
	{
		extern	GtkWidget* window;
		char* customPassword = getUserInfo(user,USERNAME);
		setField(user,userPassword(customPassword),PASSWORD);
	}
	return TEST_OK;
	
  
}
void performAddUser( sUser * user,  GSList** errorList)
{
    char * commandString= generateParameters(user);
    char* username=getUserInfo(user,USERNAME);
    strcat (commandString, " 2>&1");   	  
    FILE *fp = (FILE*) popen(commandString,"r");	  
    printf(" \n %s \n ",  commandString);	 
	  
     	  char* errorDescription=calloc(sizeof(char),250);
	  char* errorDes=calloc(sizeof(char),250);
	  
	  while  (fgets(errorDes, 199-strlen(username)-2, fp) != NULL){	  }   
	  
	  
	  if (strlen(errorDes)!=0)
	  {
		  errorDes[strlen(errorDes)]=0;
		  strcat(errorDescription,username);
		  strcat(errorDescription, ": ");
		  strcat(errorDescription,&(errorDes[8]));	
		  *errorList=g_slist_append(*errorList, (gpointer) errorDescription);
	  }
	  else
	  {
		free(errorDescription);
	  }
	     	  
	  free(errorDes);	  
	  pclose(fp);	     	  
	  free(commandString);	 
}
int addUsers(int manyUsers)
{
  int ret;
  GSList* errorList=0;
  ret=performTests(manyUsers);
  if (ret<=0)
  {
   
    sUser* user= createUser(detectOperation());    
    
    if (usersToAdd()!=-1)
    {      
      char* number=malloc(6);

      char* genericUsername=malloc(strlen(getUserInfo(user,USERNAME)));
      strcpy(genericUsername,getUserInfo(user,USERNAME));      
        
      char* genericHomeFolder=malloc(strlen(getUserInfo(user,FOLDER)));      
      strcpy(genericHomeFolder,getUserInfo(user,FOLDER));
      
      char*username;
      char*t;
      int startNumber=getStartNumber();
      for (int i=startNumber; i<usersToAdd()+startNumber  ; i++)
      {      
	
	sprintf(number,"%d",i);
	
	username=replaceMultipleCharacter(genericUsername,i);
	setField(user,username,USERNAME);
	free(username);	
		
	t=replaceMultipleCharacter(genericHomeFolder,i);
	setField(user,t,FOLDER);
	free(t);
	
	if (user->UID!=-1)
	   user->UID=user->UID+1;
	
	
	if (appGUI_setPassword(user)==CANCEL_OPERATION)
	{
	
	  g_slist_foreach(errorList, (GFunc)free, NULL);
      g_slist_free(errorList);
      errorList = NULL;

	  free(number);	 
	  free(genericUsername);	 
	  free(genericHomeFolder);
	  return 0;
	}	
	performAddUser(user,&errorList);  	
      }
      
      free(number);      
      free(genericUsername);     
      free(genericHomeFolder);     
    }
    else
    {
      performAddUser(user,&errorList);        
    }
    if (errorList!=0)
    {
	informErrorList(errorList);
    }
    else
    {
	gtk_main_quit();
    }
    g_slist_foreach(errorList, (GFunc)free, NULL);
    g_slist_free(errorList);
    errorList = NULL;
    deleteUser(user);
    return TEST_OK;
  }
  else
  {
    g_slist_foreach(errorList, (GFunc)free, NULL);
    g_slist_free(errorList);
    errorList = NULL;    
    return ret;
  }
  
}

int usernameExist(const char * username)
{
   FILE* f=popen("cat /etc/passwd | cut -d ':' -f1","r");	
  char systemNames[30];       
  while (!(feof(f)))
  {
    fscanf(f,"%s",systemNames);
    
    if (strcmp(username, systemNames) ==0)
    {      
      pclose(f);
      return 1;
    }
    
  }
  pclose(f);
  return 0;
  
}
