#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <string.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"
#include "generateParameter.h"
#include "gui/errors.h"
#include "applicationGUI.h"
#include "test.h"
void on_btnCancel_clicked   (GtkButton       *button,       gpointer         user_data)
{
gtk_main_quit ();
}
void on_addUserWindow_destroy   (GtkObject       *object,   gpointer         user_data)
{
gtk_main_quit ();
}
void showWidget(GtkWidget* w, int b)
{

	if (b)
		gtk_widget_show(w);
	else
		gtk_widget_hide(w);

}
void on_toggleManyUsers_toggled (GtkToggleButton *togglebutton,  gpointer         user_data)
{
      extern GtkWidget * window;
      int buttonState= gtk_toggle_button_get_active  (togglebutton);
      GtkWidget* lblDescription=	lookup_widget (window,"lblReference");
	showWidget(lblDescription, buttonState);
      //gtk_widget_set_visible (lblDescription, buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("txtUserNumber"),buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("rbAutoPassword"),buttonState);   
      gtk_widget_set_sensitive(widgetFromWindow("rbCustomPassword"),buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("lblUserNumber"),buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("rbPasswordAsUsername"),buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("lblStartNumber"),buttonState);
      gtk_widget_set_sensitive(widgetFromWindow("txtStartNumber"),buttonState);

}


void  on_btnAccept_clicked   (GtkButton       *button,      gpointer         user_data)
{
    
    int ok= addUsers(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widgetFromWindow("toggleManyUsers"))));
    if (ok>0)
    {
        informError(ok);
    }
}

void
on_txtPassword1_changed  (GtkEditable     *editable,       gpointer         user_data)
{
 GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)editable);;

 const char* texto= gtk_entry_get_text((GtkEntry*) editable);
  GtkEntry * pswd=  GTK_ENTRY(lookup_widget(window,"txtPassword"));
  GtkImage * imgPassword= GTK_IMAGE( lookup_widget(window, "imgPassword"));
  if (strcmp(texto, gtk_entry_get_text(pswd)) ==0)
  {		
    gtk_image_set_from_stock(imgPassword,  GTK_STOCK_YES  ,2);	
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),1);
  }
  else
  {
    gtk_image_set_from_stock(imgPassword, GTK_STOCK_DIALOG_ERROR , 2);
  }
}


void
on_txtName_changed   (GtkEditable     *editable,         gpointer         user_data)
{
 extern    GtkWidget       *window;
  GtkEntry*       txtHomeUserName= GTK_ENTRY( lookup_widget(window, "txtHomedir"));
  gtk_entry_set_text(txtHomeUserName, gtk_entry_get_text((GtkEntry*) editable));
  const char* texto= gtk_entry_get_text((GtkEntry*) editable);
  GtkImage * imgUsername= GTK_IMAGE( lookup_widget(window, "imgUsername"));
  
  if (usernameExist(texto))
  {   
      gtk_image_set_from_stock(imgUsername,  GTK_STOCK_DIALOG_ERROR ,2);     
    }
    else
    {
      gtk_image_set_from_stock(imgUsername, GTK_STOCK_YES, 2);
    }
  
  
}


void
on_btnAcceptCustomPassword_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_btnCancelCustomPassword_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	
}

void
on_txtPassword1Dialog_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)editable);;

 const char* texto= gtk_entry_get_text((GtkEntry*) editable);
  GtkEntry * pswd=  GTK_ENTRY(lookup_widget(window,"txtPassword"));
  GtkImage * imgPassword= GTK_IMAGE( lookup_widget(window, "imgPassword"));
  if (strcmp(texto, gtk_entry_get_text(pswd)) ==0)
  {		
    gtk_image_set_from_stock(imgPassword,  GTK_STOCK_YES  ,2);	
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),1);
  }
  else
  {
    gtk_image_set_from_stock(imgPassword, GTK_STOCK_DIALOG_ERROR , 2);
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),0);
  
}
}


void
on_txtPasswordDialog_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
    GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)editable);;

 const char* texto= gtk_entry_get_text((GtkEntry*) editable);
  GtkEntry * pswd=  GTK_ENTRY(lookup_widget(window,"txtPassword1"));
  GtkImage * imgPassword= GTK_IMAGE( lookup_widget(window, "imgPassword"));
  if (strcmp(texto, gtk_entry_get_text(pswd)) ==0)
  {		
    gtk_image_set_from_stock(imgPassword,  GTK_STOCK_YES  ,2);	
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),1);
  }
  else
  {
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),0);

    gtk_image_set_from_stock(imgPassword, GTK_STOCK_DIALOG_ERROR , 2);
  }
}


void passwordSensitive(GtkToggleButton *togglebutton)
{
  
   GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)togglebutton);
  int buttonState= gtk_toggle_button_get_active  (togglebutton);
  gtk_widget_set_sensitive(lookup_widget(window,"txtPassword"),!buttonState);
  gtk_widget_set_sensitive(lookup_widget(window,"txtPassword1"),!buttonState);
  gtk_widget_set_sensitive(lookup_widget(window,"lblPassword"),!buttonState);
  gtk_widget_set_sensitive(lookup_widget(window,"imgPassword"),!buttonState);

}
void
on_rbCustomPassword_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
 
  passwordSensitive(togglebutton);
}


void
on_rbPasswordAsUsername_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  passwordSensitive(togglebutton);
}


void
on_txtPassword_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)editable);;

 const char* texto= gtk_entry_get_text((GtkEntry*) editable);
  GtkEntry * pswd=  GTK_ENTRY(lookup_widget(window,"txtPassword1"));
  GtkImage * imgPassword= GTK_IMAGE( lookup_widget(window, "imgPassword"));
  if (strcmp(texto, gtk_entry_get_text(pswd)) ==0)
  {		
    gtk_image_set_from_stock(imgPassword,  GTK_STOCK_YES  ,2);	
    gtk_widget_set_sensitive(lookup_widget(window,"btnAccept"),1);
  }
  else
  {
    gtk_image_set_from_stock(imgPassword, GTK_STOCK_DIALOG_ERROR , 2);
  }
}

void
on_chkbMostrarPassword_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkWidget       *window=  gtk_widget_get_parent     ((GtkWidget*)togglebutton);;
  gtk_entry_set_visibility(GTK_ENTRY(lookup_widget(window,"txtPassword")),gtk_toggle_button_get_active  (togglebutton));
  gtk_entry_set_visibility(GTK_ENTRY(lookup_widget(window,"txtPassword1")),gtk_toggle_button_get_active  (togglebutton));     
  
}


void
on_rbAutoPassword_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  
}
